package com.example.demo;

import java.util.Date;
import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/api")
public class ApiController {
    private final Logger log = LoggerFactory.getLogger(ApiController.class);

    @GetMapping
    public String get(@RequestParam(name = "name", defaultValue = "World") String name) {
        return String.format("Hello, %s!", name);
    }

    @GetMapping("/test")
    public String getTest() {
        return new Date().toString();
    }

    @GetMapping("/num")
    public Integer getNum() {
        return 10;
    }

    @GetMapping("/list")
    public List<Integer> getList() {
        return List.of(10, 20, 30, 40, 50);
    }

    @GetMapping("/map")
    public TestDto getMap() {
        return new TestDto("Ivanov", "Ivan");
    }

    @PostMapping("/map")
    public TestDto postMap(@RequestBody TestDto testDto) {
        return testDto;
    }

    @PostMapping
    public String postMethodName(@RequestBody String name) {
        return get(name);
    }

    @PutMapping("/{name}")
    public String putMethodName(@PathVariable(name = "name") String name, @RequestBody String entity) {
        log.info("The body value is {}", entity);
        return get(name);
    }
}
